/*  CAO Compiler
    Copyright (C) 2014 Cryptography and Information Security Group, HASLab - INESC TEC and Universidade do Minho

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#ifndef CAO_BOOL_H
#define CAO_BOOL_H

#include "CAO_globals.h"

#ifdef __cplusplus

#include <iostream>

extern "C" {
#endif

	#define CAO_bool_init(a,b) a = b
	#define CAO_bool_assign(a,b) a = b
	#define CAO_bool_equal(a,b,c) a = ((b) == (c))
	#define CAO_bool_nequal(a,b,c) a = ((b) != (c))
	#define CAO_bool_or(a,b,c) a = ((b) | (c))
	#define CAO_bool_and(a,b,c) a = ((b) & (c))
	#define CAO_bool_xor(a,b,c) a = ((b) ^ (c))
	#define CAO_bool_not(a,b) a = ((~(b)) & 1)

	CAO_RES CAO_bool_dump(CAO_bool);

#ifdef __cplusplus
}
#endif

#endif
